#!/usr/bin/perl
#


=head1 $0

=head1 SYNOPSIS

 correlation.pl gs-file sys-file

 Requires R

 Authors: Eneko Agirre and Aitor Soroa

=cut

open(I,$ARGV[0]) or die $! ;
$i = 0;
while (<I>) {
	chomp ;
	next if /^\#/ ;
	@fields = (split(/\s+/,$_)) ;
	($n1,$n2,$score) = @fields ;
	warn "number of fields is not 3: $_\n" if ($#fields !=2) ;
	#warn "not a number $score" unless $score =~ /^-?\d+(\.\d+)?$/ ;
	$code{"$n1 $n2"} = $i ;
	$a->[$i++] = $score ;
}
close(I) ;

$j = 0 ;
open(I,$ARGV[1]) or die $! ;
while (<I>) {
	chomp ;
	next if /^\#/ ;
	@fields = (split(/\s+/,$_)) ;
	($n1,$n2,$score) = @fields ;
	warn "number of fields is not 3: $_\n" if ($#fields !=2) ;
	#warn "not a number $_\n" unless $score =~ /^-?\d+(\.\d+)?$/ ;
	warn "$n1 $n2 not in 2nd file\n" if ! defined $code{"$n1 $n2"} ;
	next if ! defined $code{"$n1 $n2"} ;
	#print STDERR "> $n1 $n2 -0\n" if $score =~ /-0(\.0+)?$/ ;
	$b->[$code{"$n1 $n2"}] = sprintf("%2e",$score) ;
	$j++ ;
}
close(I) ;

# compute Spearman using R

open(O,">/tmp/R.$$.in") or die $! ;
print O "a <- c(" . join(",",@$a) . ")\n" ;
print O "b <- c(" . join(",",@$b) . ")\n" ;
print O "cor.test(a, b, method=\"pearson\")\n" ;
print O "cor.test(a, b, method=\"spearman\")\n" ;

# compute confidence
# 1st compute rank for each of values, taking into account the weights (ties get average ranks)
print O "arank <- rank(-a, ties.method=\"average\")\n" ;
print O "brank <- rank(-b, ties.method=\"average\")\n" ;
print O "arank\n" ;
print O "brank\n" ;
# pearson now gives confidence scores (pearson of ranks is equivalent to spearman)
print O "cor.test(arank, brank, method=\"pearson\",conf.level=0.95)\n" ;
close(O) ;

$status = system "(cat /tmp/R.$$.in | R --vanilla > /tmp/R.$$.out 2>&1)"; # >& /dev/null" ;
die "Program R exited unexpectedly: $?" unless $status == 0 ;

open(I,"/tmp/R.$$.out") or die $! ;
while (<I>) {
	if (/Pearson\'s product-moment/ && ! $pearson) {
		while (<I>) {
			next if ! /^(-?[01]\.?\d*)\s*$/ ;
			$pearson = $1 ;
			last ;
		}
	}
	if (/Spearman\'s rank correlation/) {
		while (<I>) {
			next if ! /^(-?[01]\.\d+)\s*$/ ;
			$spearman = $1 ;
			last ;
		}
	}
	if (/Pearson\'s product-moment/) {
		while (<I>) {
			next if ! /^\s*(-?[01]\.\d+)\s+(-?[01]\.\d+)\s*$/ ;
			$conf1 = $1 ;
			$conf2 = $2 ;
			last ;
		}
	}
}

printf "%3f\n", $spearman;
