#!/bin/bash

declare -a arr=("MAP-TXT.tar.bz2" "JOINT-TXT.tar.bz2" "JOINTC-TXT.tar.bz2" "MAP-KB.tar.bz2" "JOINT-KB.tar.bz2" "JOINTC-KB.tar.bz2" "MAP-HYB.tar.bz2" "JOINT-HYB.tar.bz2" "JOINTC-HYB.tar.bz2")
mkdir -p results
for i in "${arr[@]}"; do
	echo "Getting http://ixa2.si.ehu.es/ukb/embeddings/$i"
	wget --quiet "http://ixa2.si.ehu.es/ukb/embeddings/$i"
	j=$(basename $i .tar.bz2)
	method=$(echo $j | sed -e 's/^\([^-]*\)-.*$/\1/')
	corpus=$(echo $j | sed -e 's/^[^-]*-\(.*\)$/\1/')
	script="run_${method}.sh"
	ofile="results/${method}_${corpus}.out"
	echo "tar xjf $i"
	tar xjf $i
	echo "bash ${script} ${corpus} > ${ofile}"
	bash ${script} ${corpus} > ${ofile}
	rm -f $i
	rm -f embeddings/*
	exit
done
