#!/usr/bin/perl

use warnings;
use strict;
use Getopt::Long;

my $o1fitx = '';
my $o2fitx = '';
my $o3fitx = '';
my $ifitx1 = '';
my $ifitx2 = '';
my $ds1fitx = '';
my $ds2fitx = '';
my $ds3fitx = '';
my $femb1aux = rand(123).'.emb';
my $femb2aux = rand(456).'.emb';

GetOptions ('o1=s' => \$o1fitx,
	    'o2=s' => \$o2fitx,
	    'o3=s' => \$o3fitx,
	    'emb1=s' => \$ifitx1,
	    'emb2=s' => \$ifitx2,
	    'ds1=s' => \$ds1fitx,
	    'ds2=s' => \$ds2fitx,
	    'ds3=s' => \$ds3fitx,);


                                           #############
###########################################   Nagusia   ####################################################
                                           #############

######Aldagaiak#######

#IzenBek Hash-a
#use Hash::Case::Preserve;
#tie my %hIzenBek;
my %hIzenBek1;
my %hIzenBek2;
my $hZerrenda1;
my $hZerrenda2;
my $izenKop1 = 0;
my $izenKop2 = 0;
my $dim;

#my $hemb1 = 'hemb1';
#my $hemb2 = 'hemb2';
#my $hemb1aux = 'hemb1AUX';
#my $hemb2aux = 'hemb2AUX';

######Fitxategiak ireki########
open(FDSET1,"$ds1fitx") or die("Error opening $ds1fitx dataset file");
open(my $hemb1,"$ifitx1") or die("Error opening $ifitx1 embedding file");
open(my $hemb2,"$ifitx2") or die("Error opening $ifitx2 embedding file");
open(my $hemb1aux,">$femb1aux") or die("Error opening $femb1aux auxiliary embedding file");
open(my $hemb2aux,">$femb2aux") or die("Error opening $femb2aux auxiliary embedding file");
open(FOUT1,">$o1fitx") or die("Error opening $o1fitx output file");
if($ds2fitx ne ''){
	open(FDSET2, "$ds2fitx") or die("Error opening $ds2fitx dataset file");
	open(FOUT2, ">$o2fitx") or die("Error opening $o2fitx output file");
}
if($ds3fitx ne ''){
	open(FDSET3, "$ds3fitx") or die("Error opening $ds3fitx dataset file");
	open(FOUT3, ">$o3fitx") or die("Error $o3fitx output file");
}

#######ArrayaHasieratu#########

my $fhds1;
my $fhds2;
my $fhds3;
my $fho1;
my $fho2;
my $fho3;
$fhds1 = \*FDSET1;
$fho1 = \*FOUT1;

hasiZerrenda($fhds1);
close(FDSET1);

if($ds2fitx ne ''){
	$fhds2 = \*FDSET2;
	$fho2 = \*FOUT2;
	hasiZerrenda($fhds2);
	close(FDSET2);
}
if($ds3fitx ne ''){
	$fhds3 = \*FDSET3;
	$fho3 = \*FOUT3;
	hasiZerrenda($fhds3);
	close(FDSET3);
}

#######Embeddingak bilatu#######
bilaEmbeddings($izenKop1,$hemb1,$hemb1aux, $femb1aux, $hZerrenda1);
bilaEmbeddings($izenKop2,$hemb2,$hemb2aux, $femb2aux, $hZerrenda2);

######Hash-a hasieratu########
hasiHash($hemb1aux, $femb1aux, \%hIzenBek1);
hasiHash($hemb2aux, $femb2aux, \%hIzenBek2);

#######Atzekotasuna###########
open(FDSET1,"$ds1fitx") or die("Error opening $ds1fitx dataset file");
azpAntzeko(\%hIzenBek1,\%hIzenBek2,$fhds1,$fho1);

if($ds2fitx ne ''){
	open(FDSET2,"$ds2fitx") or die("Error opening $ds2fitx dataset file");
	azpAntzeko(\%hIzenBek1,\%hIzenBek2,$fhds2,$fho2);
}
if($ds3fitx ne ''){
	open(FDSET3,"$ds3fitx") or die("Error opening $ds3fitx dataset file");
	azpAntzeko(\%hIzenBek1,\%hIzenBek2,$fhds3,$fho3);
}

######Fitxategiak itxi########
close (FDSET1);
close ($hemb1);
close ($hemb2);
close ($hemb2aux);
close ($hemb1aux);
close (FOUT1);
if($ds2fitx ne ''){
	close (FOUT2);
	close (FDSET2);
}
if($ds3fitx ne ''){
	close (FOUT3);
	close (FDSET3);
}

unlink ($femb1aux);
unlink ($femb2aux);

					   ###################
###########################################   Azpiprogramak   ####################################################
                                           ###################

sub hasiZerrenda{
	my $izenak_;
	my $zenbWords_ = 0;
	my $fitx =$_[0];

	while($izenak_ = <$fitx>){
		chomp($izenak_);
		my @aBikotea_ = split(/\t|\s/,$izenak_);

		if (!$hZerrenda1->{$aBikotea_[0]}){
			$hZerrenda1->{$aBikotea_[0]} = 1;
			$izenKop1++;
		}

		if (!$hZerrenda2->{$aBikotea_[1]}){
			$hZerrenda2->{$aBikotea_[1]} = 1;
			$izenKop2++;
		}

	}
}

sub bilaEmbeddings{
	my $izenKop_ = $_[0];
	my $hemb_ = $_[1];
	my $hembaux_ = $_[2];
	my $fembaux_ = $_[3];
	my $hZerrenda_ = $_[4];
	my $zenbWords_ = 0;
	my $zenbLines_ = 0;
	my $zenbBekt_ = 0;
	my $izena_;
	my $read_dim_ = 1;
	my $izena_bekt_;
	my @izena_bekt_aux_;
	my $zenbEmb_;
	my @aFlagZerrenda_ = 0 x 5000;

	while ($izena_bekt_ = <$hemb_>){
		chomp($izena_bekt_);
		@izena_bekt_aux_ = split (/ /, $izena_bekt_);
		$izena_ = $izena_bekt_aux_[0];
		if ($read_dim_ == 1){
			$read_dim_ = 0;
			$dim = $izena_bekt_aux_[1];
		}

		if($hZerrenda_->{$izena_}){
			$hZerrenda_->{$izena_} = 2;
			print($hembaux_ "$izena_ ");
			for($zenbEmb_ = 0;$zenbEmb_ < $dim; $zenbEmb_++){
				print($hembaux_ "$izena_bekt_aux_[$zenbEmb_+1] ");
			}
			print($hembaux_ "\n");
			$zenbLines_++;
			if($zenbLines_ >= $izenKop_){
				last;
			}
		}
	}
	close($hembaux_);

	open($hembaux_,"+>>$fembaux_") or die("Error opening $fembaux_ auxiliary embedding file");
	foreach my $key (keys %{$hZerrenda_}){ # ($zenbWords_ = 0; $zenbWords_ < $izenKop_ ; $zenbWords_++){
		if($hZerrenda_->{$key} == 1){
			#print("$key hitza ez dago embeddingetan!!\n");
			print($hembaux_ "$key"." -0");
			print($hembaux_ "\n");
		}
	}
	close($hembaux_);

	$zenbLines_ = 0;
}


sub hasiHash{
	#use Hash::Case::Preserve;
        #tien my %hIzenBek_;
	my $hembaux_ = $_[0];
	my $fembaux_ = $_[1];
	my $hIzenBek_ = $_[2];
	my ($izena_bekt_);
	my @izena_bekt_aux_;
	my $izena_;
	my @bektorea_;
	my @bektoreaOut_;
	my $zenbBekt_ = 0;
	my $zenbWords_ = 0;

	open($hembaux_,"$fembaux_") or die("Error opening $fembaux_ auxiliary embedding file");
	while($izena_bekt_ = <$hembaux_>){
		chomp($izena_bekt_);
		@izena_bekt_aux_ = split (/ /, $izena_bekt_);
		$izena_ = $izena_bekt_aux_[0];
		if ($izena_bekt_aux_[1] ne "-0"){
		    for($zenbBekt_ = 0; $zenbBekt_ < $dim; $zenbBekt_++){
			$bektorea_[$zenbWords_][$zenbBekt_] = $izena_bekt_aux_[$zenbBekt_+1];
		    }
		}else{
		    for($zenbBekt_ = 0; $zenbBekt_ < $dim; $zenbBekt_++){
			 $bektorea_[$zenbWords_][$zenbBekt_] = 0;
		    }
	        }
		${$hIzenBek_}{$izena_} = $bektorea_[$zenbWords_];
		#print("$izena_ : $hIzenBek_{$izena_}\n");
		$zenbWords_++;
	}

}

sub azpAntzeko{

	my ($bikotea_, @aBikoteak_);
	my $hwordvec1 = $_[0];
	my $hwordvec2 = $_[1];
	my $dsf = $_[2];
	my $of = $_[3];
	my ($v_, $w_);
	my $zenbLerro_ = 0;
	my $zenbEmb_ = 0;
	my $i_ = 0;
	my $sim_ = 0;

	while($bikotea_ = <$dsf>){

		 chomp($bikotea_);
		 @aBikoteak_ = split (/\t|\s/, $bikotea_);
		 $v_ = $hwordvec1->{$aBikoteak_[0]};
		 $w_ = $hwordvec2->{$aBikoteak_[1]};
		 $sim_ = azpKosinu($v_,$w_);
		#######Similarity output#########
		print($of "$aBikoteak_[0]\t$aBikoteak_[1]\t$sim_\n");
		$zenbLerro_++;
	}

}

sub azpKosinu{
	my $i_ = 0;
	my $sim1_ = 0;
	my ($wAux_, $vAux_);
        my ($v1_, $w1_) = @_;
	my ($f1_, $f2_);

	$f1_ = 0;
	$f2_ = 0;

	if(($v1_->[0] == 0) || ($w1_->[0] == 0)){
		$sim1_ = "-0";
	}else{
		for ($i_ = 0; $i_ < $dim; $i_++){
			$f1_ += ($w1_->[$i_] * $v1_->[$i_]);
			$wAux_ += $w1_->[$i_] * $w1_->[$i_];
			$vAux_ += $v1_->[$i_] * $v1_->[$i_];
		}
		$f2_ = sqrt($wAux_) * sqrt($vAux_);
		$sim1_ = $f1_/$f2_;
	}

return($sim1_);

}
