#!/usr/bin/perl

use warnings;
use strict;
use Getopt::Long;

my $o1fitx = '';
my $o2fitx = '';
my $o3fitx = '';
my $ifitx = '';
my $ds1fitx = '';
my $ds2fitx = '';
my $ds3fitx = '';

GetOptions ('o1=s' => \$o1fitx,
	    'o2=s' => \$o2fitx,
	    'o3=s' => \$o3fitx,
	    'emb=s' => \$ifitx,
	    'ds1=s' => \$ds1fitx,
	    'ds2=s' => \$ds2fitx,
	    'ds3=s' => \$ds3fitx,);

my $embaux = rand(123).".tmp";

                                           #############
###########################################   Nagusia   ####################################################
                                           #############

######Aldagaiak#######

#IzenBek Hash-a
#use Hash::Case::Preserve;
#tie my %hIzenBek;
my %hIzenBek;
my $hZerrenda;
my $izenKop = 0;
my $dim;

######Fitxategiak ireki########
open(FDSET1, "$ds1fitx") or die("Error opening $ds1fitx dataset file");
open(FOUT1, ">$o1fitx") or die("Error opening $o1fitx output file");
if($ds2fitx ne ''){
	open(FDSET2, "$ds2fitx") or die("Error opening $ds2fitx dataset file");
	open(FOUT2, ">$o2fitx") or die("Error opening $o2fitx output file");
}
if($ds3fitx ne ''){
	open(FDSET3, "$ds3fitx") or die("Error opening $ds3fitx dataset file");
	open(FOUT3, ">$o3fitx") or die("Error opening $o3fitx output file");
}
open(FEMB,  "$ifitx") or die("Error opening $ifitx embedding file");
open(FEMB2, ">$embaux") or die("Error opening $embaux auxiliary embeddings file");


#######ArrayaHasieratu#########
my $fhds1;
my $fhds2;
my $fhds3;
my $fho1;
my $fho2;
my $fho3;
$fhds1 = \*FDSET1;
$fho1 = \*FOUT1;
$izenKop = $izenKop + hasiZerrenda($fhds1);
close(FDSET1);
if($ds2fitx ne ''){
	$fhds2 = \*FDSET2;
	$fho2 = \*FOUT2;
	$izenKop = $izenKop + hasiZerrenda($fhds2);
	close(FDSET2);
}
if($ds3fitx ne ''){
	$fhds3 = \*FDSET3;
	$fho3 = \*FOUT3;
	$izenKop = $izenKop + hasiZerrenda($fhds3);
	close(FDSET3);
}

#######Embeddingak bilatu#######
bilaEmbeddings($izenKop);

######Hash-a hasieratu########
%hIzenBek = hasiHash($izenKop);

#######Atzekotasuna###########
open(FDSET1,"$ds1fitx") or die("Error opening $ds1fitx dataset file");
azpAntzeko(\%hIzenBek,$fhds1,$fho1);
if($ds2fitx ne ''){
	open(FDSET2,"$ds2fitx") or die("Error opening $ds2fitx dataset file");
	azpAntzeko(\%hIzenBek,$fhds2,$fho2);
}
if($ds3fitx ne ''){
	open(FDSET3,"$ds3fitx") or die("Error opening $ds3fitx dataset file");
	azpAntzeko(\%hIzenBek,$fhds3,$fho3);
}


######Fitxategiak itxi########
close (FDSET1);
close (FEMB);
close (FEMB2);
close (FOUT1);
if($ds2fitx ne ''){
	close (FOUT2);
	close (FDSET2);
}
if($ds3fitx ne ''){
	close (FOUT3);
	close (FDSET3);
}
unlink ($embaux);

					   ###################
###########################################   Azpiprogramak   ####################################################
                                           ###################

sub hasiZerrenda{
	my $izenak_;
	my $zenbWords_ = 0;
	my $fitx =$_[0];

	while($izenak_ = <$fitx>){
		chomp($izenak_);
		my @aBikotea_ = split(/\t|\s/,$izenak_);

		if (!$hZerrenda->{$aBikotea_[0]}){
			$hZerrenda->{$aBikotea_[0]} = 1;
			$zenbWords_++;
		}

		if (!$hZerrenda->{$aBikotea_[1]}){
			$hZerrenda->{$aBikotea_[1]} = 1;
			$zenbWords_++;
		}

	}
	return($zenbWords_);
}

sub bilaEmbeddings{
	my $izenKop_ = $_[0];
	my $zenbWords_ = 0;
	my $zenbLines_ = 0;
	my $zenbBekt_ = 0;
	my $izena_;
	my $read_dim_ = 1;
	my $izena_bekt_;
	my @izena_bekt_aux_;
	my $zenbEmb_;
	my @aFlagZerrenda_ = 0 x 5000;

	while ($izena_bekt_ = <FEMB>){
		chomp($izena_bekt_);
		@izena_bekt_aux_ = split (/ /, $izena_bekt_);
		$izena_ = $izena_bekt_aux_[0];
		if ($read_dim_ == 1){
			$read_dim_ = 0;
			$dim = $izena_bekt_aux_[1];
		}

		if($hZerrenda->{$izena_}){
			$hZerrenda->{$izena_} = 2;
			print(FEMB2 "$izena_ ");
			for($zenbEmb_ = 0;$zenbEmb_ < $dim; $zenbEmb_++){
				print(FEMB2 "$izena_bekt_aux_[$zenbEmb_+1] ");
			}
			print(FEMB2 "\n");
			$zenbLines_++;
			if($zenbLines_ >= $izenKop_){
				last;
			}
		}
	}
	close(FEMB2);

	open(FEMB2,"+>>$embaux") or die("Error opening $embaux auxiliary embedding file");
	foreach my $key (keys %{$hZerrenda}){ # ($zenbWords_ = 0; $zenbWords_ < $izenKop_ ; $zenbWords_++){
		if($hZerrenda->{$key} == 1){
	#		print("$key hitza ez dago embeddingetan!!\n");
			print(FEMB2 "$key"." -0");
			print(FEMB2 "\n");
		}
	}
	close(FEMB2);

	$zenbLines_ = 0;
}


sub hasiHash{
	#use Hash::Case::Preserve;
        #tien my %hIzenBek_;
	my %hIzenBek_;
	my ($izena_bekt_);
	my @izena_bekt_aux_;
	my $izena_;
	my @bektorea_;
	my @bektoreaOut_;
	my $zenbBekt_ = 0;
	my $zenbWords_ = 0;
	my $izenKop_ = $_[0];

	open(FEMB2,"$embaux") or die("Error opening $embaux auxiliary embedding file");
	while($izena_bekt_ = <FEMB2>){
		chomp($izena_bekt_);
		@izena_bekt_aux_ = split (/ /, $izena_bekt_);
		$izena_ = $izena_bekt_aux_[0];
		if ($izena_bekt_aux_[1] ne "-0"){
		    for($zenbBekt_ = 0; $zenbBekt_ < $dim; $zenbBekt_++){
			$bektorea_[$zenbWords_][$zenbBekt_] = $izena_bekt_aux_[$zenbBekt_+1];
		    }
		}else{
		    for($zenbBekt_ = 0; $zenbBekt_ < $dim; $zenbBekt_++){
			 $bektorea_[$zenbWords_][$zenbBekt_] = 0;
		    }
	        }
		$hIzenBek_{$izena_} = $bektorea_[$zenbWords_];
		#print("$izena_ : $hIzenBek_{$izena_}\n");
		$zenbWords_++;
	}

return %hIzenBek_;
}

sub azpAntzeko{

	my ($bikotea_, @aBikoteak_);
	my $hIzenBek_ = $_[0];
	my $dsf = $_[1];
	my $of = $_[2];
	my ($v_, $w_);
	my $zenbLerro_ = 0;
	my $zenbEmb_ = 0;
	my $i_ = 0;
	my $sim_ = 0;

	while($bikotea_ = <$dsf>){

		 chomp($bikotea_);
		 @aBikoteak_ = split (/\t|\s/, $bikotea_);
		 $v_ = $hIzenBek_->{$aBikoteak_[0]};
		 $w_ = $hIzenBek_->{$aBikoteak_[1]};
		 $sim_ = azpKosinu($v_,$w_);
		#######Similarity output#########
		print($of "$aBikoteak_[0]\t$aBikoteak_[1]\t$sim_\n");
		#print("$aBikoteak_[0]\t$aBikoteak_[1]\t$sim_\n");
		$zenbLerro_++;
	}

}

sub azpKosinu{
	my $i_ = 0;
	my $sim1_ = 0;
	my ($wAux_, $vAux_);
        my ($v1_, $w1_) = @_;
	my ($f1_, $f2_);

	$f1_ = 0;
	$f2_ = 0;

	if(($v1_->[0] == 0) || ($w1_->[0] == 0)){
		$sim1_ = "-0";
	}else{
		for ($i_ = 0; $i_ < $dim; $i_++){
			$f1_ += ($w1_->[$i_] * $v1_->[$i_]);
			$wAux_ += $w1_->[$i_] * $w1_->[$i_];
			$vAux_ += $v1_->[$i_] * $v1_->[$i_];
		}
		$f2_ = sqrt($wAux_) * sqrt($vAux_);
		$sim1_ = $f1_/$f2_;
	}

return($sim1_);

}
